/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.gatein.cdi.tests.injectionPoint;

import java.io.Serializable;
import javax.enterprise.context.SessionScoped;
import javax.enterprise.inject.Any;
import javax.enterprise.inject.Instance;
import javax.enterprise.inject.Produces;
import javax.enterprise.inject.spi.InjectionPoint;
import javax.enterprise.util.AnnotationLiteral;
import javax.inject.Inject;
import org.gatein.api.cdi.context.PortletLifecycleScoped;
import org.gatein.cdi.tests.injectionPoint.annotations.FancyGreetingQualifier;
import org.gatein.cdi.tests.injectionPoint.annotations.PortalBeanStereotype;

/**
 *
 * @author pmensik
 */
@SessionScoped
public class GreetingDecider implements Serializable {

    @Inject
    @Any
    private Instance<Greeting> greetings;
    
    public String getFancyGreeting() {
        if(greetings.isAmbiguous()) {
            return greetings.select(new AnnotationLiteral<FancyGreetingQualifier>() {}).get().greet();
        } else {
            return "";
        }
    }
    
    @Produces
    @PortalBeanStereotype
    public Greeting produceSimpleGreetingBean(InjectionPoint point) {
        Greeting greeting = new FancyGreeting();//greetings.select(new AnnotationLiteral<FancyGreetingQualifier>() {}).get();
        greeting.setClassName(point.getMember().getDeclaringClass().getSimpleName());
        return greeting;
    }
}
